# coding: utf-8
"""
    Cortex Analyst API.

    The Snowflake Cortex Analyst API is a REST API that allows end user to chat with their data leveraging semantic models to generate SQL queries.  # noqa: E501

    The version of the OpenAPI document: 0.0.1
    Contact: support@snowflake.com
    Generated by: https://openapi-generator.tech

    Do not edit this file manually.
"""

from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from typing import Union

from pydantic import BaseModel, ConfigDict, StrictInt, StrictStr

from typing import Any, ClassVar, Dict, List, Optional


class SuggestionDelta(BaseModel):
    """A model object representing the SuggestionDelta resource.

    Constructs an object of type SuggestionDelta with the provided properties.

    Parameters
    __________
    index : int, optional
        The index of the suggestions array this delta object represents
    suggestion_delta : str, optional
        The delta of a suggestion text, clients should concatenate all deltas for the same index
    """

    index: Optional[StrictInt] = None

    suggestion_delta: Optional[StrictStr] = None

    __properties = ["index", "suggestion_delta"]

    class Config:
        populate_by_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias."""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias."""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> SuggestionDelta:
        """Create an instance of SuggestionDelta from a JSON string."""
        return cls.from_dict(json.loads(json_str))

    def to_dict(
        self,
        hide_readonly_properties: bool = False,
    ) -> dict[str, Any]:
        """Returns the dictionary representation of the model using alias."""

        exclude_properties = set()

        if hide_readonly_properties:
            exclude_properties.update({})

        _dict = dict(
            self._iter(to_dict=True,
                       by_alias=True,
                       exclude=exclude_properties,
                       exclude_none=True))

        return _dict

    def to_dict_without_readonly_properties(self) -> dict[str, Any]:
        """Return the dictionary representation of the model without readonly properties."""
        return self.to_dict(hide_readonly_properties=True)

    @classmethod
    def from_dict(cls, obj: dict) -> SuggestionDelta:
        """Create an instance of SuggestionDelta from a dict."""

        if obj is None:
            return None

        if type(obj) is not dict:
            return SuggestionDelta.parse_obj(obj)

        _obj = SuggestionDelta.parse_obj({
            "index":
            obj.get("index"),
            "suggestion_delta":
            obj.get("suggestion_delta"),
        })

        return _obj


from typing import Optional, List, Dict


class SuggestionDeltaModel():

    def __init__(
        self,  # optional properties
        index: Optional[int] = None,
        suggestion_delta: Optional[str] = None,
    ):
        """A model object representing the SuggestionDelta resource.

        Constructs an object of type SuggestionDelta with the provided properties.

        Parameters
        __________
        index : int, optional
            The index of the suggestions array this delta object represents
        suggestion_delta : str, optional
            The delta of a suggestion text, clients should concatenate all deltas for the same index
        """

        self.index = index
        self.suggestion_delta = suggestion_delta

    __properties = ["index", "suggestion_delta"]

    def __repr__(self) -> str:
        return repr(self._to_model())

    def _to_model(self):
        return SuggestionDelta(
            index=self.index,
            suggestion_delta=self.suggestion_delta,
        )

    @classmethod
    def _from_model(cls, model) -> SuggestionDeltaModel:
        return SuggestionDeltaModel(
            index=model.index,
            suggestion_delta=model.suggestion_delta,
        )

    def to_dict(self):
        """Creates a dictionary of the properties from a SuggestionDelta.

        This method constructs a dictionary with the key-value entries corresponding to the properties of the SuggestionDelta object.

        Returns
        _______
        dict
            A dictionary object created using the input model.
        """
        return self._to_model().to_dict()

    @classmethod
    def from_dict(cls, obj: dict) -> SuggestionDeltaModel:
        """Creates an instance of SuggestionDelta from a dict.

        This method constructs a SuggestionDelta object from a dictionary with the key-value pairs of its properties.

        Parameters
        ----------
        obj : dict
            A dictionary whose keys and values correspond to the properties of the resource object.

        Returns
        _______
        SuggestionDelta
            A SuggestionDelta object created using the input dictionary; this will fail if the required properties are missing.
        """
        return cls._from_model(SuggestionDelta.from_dict(obj))


SuggestionDelta._model_class = SuggestionDeltaModel
