# coding: utf-8
"""
    Snowflake Iceberg Table API.

    The Snowflake Iceberg Table API is a REST API that you can use to access, update, and perform certain actions on Iceberg Table resource in a Snowflake database.  # noqa: E501

    The version of the OpenAPI document: 0.0.1
    Contact: support@snowflake.com
    Generated by: https://openapi-generator.tech

    Do not edit this file manually.
"""

from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from typing import Union

from snowflake.core.iceberg_table._generated.models.constraint import Constraint

from pydantic import ConfigDict, StrictStr

from typing import Any, ClassVar, Dict, List, Optional


class ForeignKey(Constraint):
    """A model object representing the ForeignKey resource.

    Constructs an object of type ForeignKey with the provided properties.

    Parameters
    __________
    referenced_table_name : str

    name : str, optional
        Name of the Constraint

    column_names : List[str], optional

    referenced_column_names : List[str], optional
    """

    referenced_table_name: StrictStr

    referenced_column_names: Optional[List[StrictStr]] = None

    __properties = ["name", "column_names", "constraint_type"]

    class Config:
        populate_by_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias."""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias."""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> ForeignKey:
        """Create an instance of ForeignKey from a JSON string."""
        return cls.from_dict(json.loads(json_str))

    def to_dict(
        self,
        hide_readonly_properties: bool = False,
    ) -> dict[str, Any]:
        """Returns the dictionary representation of the model using alias."""

        exclude_properties = set()

        if hide_readonly_properties:
            exclude_properties.update({})

        _dict = dict(
            self._iter(to_dict=True,
                       by_alias=True,
                       exclude=exclude_properties,
                       exclude_none=True))

        _dict[
            'constraint_type'] = Constraint.get_child_model_discriminator_value(
                'ForeignKey')

        return _dict

    def to_dict_without_readonly_properties(self) -> dict[str, Any]:
        """Return the dictionary representation of the model without readonly properties."""
        return self.to_dict(hide_readonly_properties=True)

    @classmethod
    def from_dict(cls, obj: dict) -> ForeignKey:
        """Create an instance of ForeignKey from a dict."""

        if obj is None:
            return None

        if type(obj) is not dict:
            return ForeignKey.parse_obj(obj)

        _obj = ForeignKey.parse_obj({
            "name":
            obj.get("name"),
            "column_names":
            obj.get("column_names"),
            "referenced_table_name":
            obj.get("referenced_table_name"),
            "referenced_column_names":
            obj.get("referenced_column_names"),
        })

        return _obj


from typing import Optional, List, Dict

from snowflake.core.iceberg_table._generated.models.constraint import Constraint


class ForeignKeyModel(Constraint):

    def __init__(
        self,
        referenced_table_name: str,
        # optional properties
        name: Optional[str] = None,
        column_names: Optional[List[str]] = None,
        referenced_column_names: Optional[List[str]] = None,
    ):
        """A model object representing the ForeignKey resource.

        Constructs an object of type ForeignKey with the provided properties.

        Parameters
        __________
        referenced_table_name : str

        name : str, optional
            Name of the Constraint

        column_names : List[str], optional

        referenced_column_names : List[str], optional
        """

        super().__init__(
            name=name,
            column_names=column_names,
        )
        self.referenced_table_name = referenced_table_name
        self.referenced_column_names = referenced_column_names

    __properties = ["name", "column_names", "constraint_type"]

    def __repr__(self) -> str:
        return repr(self._to_model())

    def _to_model(self):
        return ForeignKey(
            name=self.name,
            column_names=self.column_names,
            referenced_table_name=self.referenced_table_name,
            referenced_column_names=self.referenced_column_names,
        )

    @classmethod
    def _from_model(cls, model) -> ForeignKeyModel:
        return ForeignKeyModel(
            name=model.name,
            column_names=model.column_names,
            referenced_table_name=model.referenced_table_name,
            referenced_column_names=model.referenced_column_names,
        )

    def to_dict(self):
        """Creates a dictionary of the properties from a ForeignKey.

        This method constructs a dictionary with the key-value entries corresponding to the properties of the ForeignKey object.

        Returns
        _______
        dict
            A dictionary object created using the input model.
        """
        return self._to_model().to_dict()

    @classmethod
    def from_dict(cls, obj: dict) -> ForeignKeyModel:
        """Creates an instance of ForeignKey from a dict.

        This method constructs a ForeignKey object from a dictionary with the key-value pairs of its properties.

        Parameters
        ----------
        obj : dict
            A dictionary whose keys and values correspond to the properties of the resource object.

        Returns
        _______
        ForeignKey
            A ForeignKey object created using the input dictionary; this will fail if the required properties are missing.
        """
        return cls._from_model(ForeignKey.from_dict(obj))


ForeignKey._model_class = ForeignKeyModel
